unit ProcMan;

interface
uses
  Windows, SysUtils, Classes, PSAPI, TlHelp32;

const
  THREAD_TERMINATE            = ($0001);
  {$EXTERNALSYM THREAD_TERMINATE}
  THREAD_SUSPEND_RESUME       = ($0002);
  {$EXTERNALSYM THREAD_SUSPEND_RESUME}
  THREAD_GET_CONTEXT          = ($0008);
  {$EXTERNALSYM THREAD_GET_CONTEXT}
  THREAD_SET_CONTEXT          = ($0010);
  {$EXTERNALSYM THREAD_SET_CONTEXT}
  THREAD_SET_INFORMATION      = ($0020);
  {$EXTERNALSYM THREAD_SET_INFORMATION}
  THREAD_QUERY_INFORMATION    = ($0040);
  {$EXTERNALSYM THREAD_QUERY_INFORMATION}
  THREAD_SET_THREAD_TOKEN     = ($0080);
  {$EXTERNALSYM THREAD_SET_THREAD_TOKEN}
  THREAD_IMPERSONATE          = ($0100);
  {$EXTERNALSYM THREAD_IMPERSONATE}
  THREAD_DIRECT_IMPERSONATION = ($0200);
  {$EXTERNALSYM THREAD_DIRECT_IMPERSONATION}

  THREAD_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED or SYNCHRONIZE or $3FF);
  {$EXTERNALSYM THREAD_ALL_ACCESS}

  SYNCHRONIZE              = ($00100000);
  {$EXTERNALSYM SYNCHRONIZE}

type
TGrey=array[0..255] of Cardinal;
PRRec=record
PID, VDM:Cardinal;
Time:string[9];
Name:string;
end;
PRSnapShoot=array [0..255] of prrec;

var
    FProcList: array of DWORD;

function OpenThread( dwDesiredAccess: DWORD ; bInheritHandle: Boolean; dwThreadId, PID: DWORD ): THandle; stdcall;
{$EXTERNALSYM OpenThread}
procedure EnablePrivilege(lpszPrivilege:LPCTSTR);
procedure FillProcData(var ex: prsnapshoot);
procedure ListProcX(var ex: prsnapshoot);
function AppKill(PID, VDM: cardinal):boolean;
procedure BuildThreadsList(ProcessID: DWORD; var ex:TGrey);
procedure SuspendProc(PID:cardinal);
procedure ResumeProc(PID:cardinal);
procedure Logoff(atype: integer);
function FileNameEX(aa: string): string;
implementation

function FileNameEX(aa: string):string; //
var
x:integer;
bufx:pchar;
fn:pchar;
a:string;
wfd: _WIN32_FIND_DATA;
begin
a:=copy(aa, pos(':',aa)-1, length(aa));
//getmem(wfd, sizeof(wfd));
//if fileexists(a) then
//  begin
//    findfirstfile(pchar(a), wfd);
//    a:=wfd.Cfilename;
//  end;
//freemem(wfd);
{getmem(bufx, 4096);
x:=GetFullPathName(pchar(a),4096, bufx, fn);
result:=copy(bufx, 1, x);
freemem(bufx);}
result:=expandfilename(a);
end;

procedure Logoff(atype: integer);//Logoff/Shutdown/Reboot
begin
if Win32Platform = VER_PLATFORM_WIN32_NT then
  begin
    EnablePrivilege('SeShutdownPrivilege');
    EnablePrivilege('SeSystemEnvironmentPrivilege');
  end;
case atype of
1: ExitWindowsEx(EWX_SHUTDOWN+EWX_FORCE,1);
2: ExitWindowsEx(EWX_REBOOT+EWX_FORCE,1);
else ExitWindowsEx(EWX_LOGOFF+EWX_FORCE,1);
  end;
end;

function OpenThread( dwDesiredAccess: DWORD ; bInheritHandle: Boolean; dwThreadId, PID: DWORD ): THandle; stdcall; //   thread'.   2000/XP
type
xoa=packed array[1..6] of DWORD;
id=packed array[1..2] of DWORD;
TOTXP2000 = function ( a: DWORD; b: Boolean; c: DWORD ): THandle; stdcall;
TOTNT = function (i:PHANDLE; a:DWORD; b:xoa; c: id): THandle; stdcall;
var
cid: id;
oa: xoa;
otXP2000: TOTXP2000;
otNT: TOTNT;
FuncPtr: TFarProc;
hDll: THandle;

begin
result:=dwThreadID;
// In Win 2000 and XP we are calling OpenThread from Kernel32.dll
{ try
    hDll:=LoadLibrary('kernel32');
    FuncPtr:=GetProcAddress(hDLL,'OpenThread');
    if FuncPtr<>nil then
      begin
        @otXP2000:=FuncPtr;
        result:=otXP2000( dwDesiredAccess, bInheritHandle, dwThreadId);
        FuncPtr:=nil;
      end;
  finally
    FreeLibrary(hDll);
  end;
}
if result<>dwThreadID then exit;
// In Win NT 4.0 we are calling NtOpenThread from ntdll.dll
  try
    hDll:=LoadLibrary('ntdll');
    FuncPtr:=GetProcAddress(hDLL,'NtOpenThread');
    if FuncPtr<>nil then
      begin
        @otNT:=FuncPtr;
        cid[1]:=PID;
        cid[2]:=dwThreadID;
        oa[1]:=$18; oa[2]:=$0; oa[3]:=$0;
        oa[4]:=$0; oa[5]:=$0; oa[6]:=$0;
        otNT(@result, dwDesiredAccess, oa, cid);
        FuncPtr:=nil;
      end;
  finally
    FreeLibrary(hDll);
  end;
if result<>dwThreadID then exit;

end;

procedure EnablePrivilege(lpszPrivilege:LPCTSTR);//    Win NT
{
  Enable privilege for Windows NT
}
 var
hToken: THANDLE;
tp  : TOKEN_PRIVILEGES;
luid: Int64;
tpPrevious: TOKEN_PRIVILEGES;
cbPrevious : DWORD;
 begin
cbPrevious := sizeof(TOKEN_PRIVILEGES);
    if (not LookupPrivilegeValue( Nil, lpszPrivilege, luid ) )then exit;
    if( not OpenProcessToken( GetCurrentProcess(),
                            TOKEN_QUERY or TOKEN_ADJUST_PRIVILEGES,
                            hToken ) ) then exit;
    tp.PrivilegeCount:= 1;
    tp.Privileges[0].Luid := luid;
    tp.Privileges[0].Attributes := (SE_PRIVILEGE_ENABLED);//0;
    AdjustTokenPrivileges( hToken, FALSE, tp, sizeof(TOKEN_PRIVILEGES),
                           tpPrevious, cbPrevious );
    if( GetLastError <> ERROR_SUCCESS ) then
    else
    CloseHandle( hToken );
end;

procedure FillProcData(var ex: prsnapshoot); //       PID'  Win NT
type
  TVDMEnum = function (ntvdmPID: DWORD; callback: pointer; lparam: pointer): integer; stdcall;
var
  I: Integer;
  Count: DWORD;
  hInstLib2, ProcHand: THandle;
  FuncPtr: Pointer;
  ModHand: HMODULE;
  ModName: array[0..MAX_PATH] of char;
  VDMEnum: TVDMEnum;

  function CallBack(dwThreadId: DWORD; hMod16, hTask16:WORD; pszModName, pszFileName: PChar; var lpUserDefined: prsnapshoot): boolean; stdcall;
  var
    exx: prsnapshoot;
  begin
    exx:=lpUserDefined;
    exx[0].PID:=exx[0].PID+1;
    exx[exx[0].PID].Name:=FileNameEX(pszFileName);
    exx[exx[0].PID].PID:=hTask16;
    exx[exx[0].PID].VDM:=exx[exx[0].PID-1].VDM;
    exx[exx[0].PID].Time:=timetostr(now);
    lpUserDefined:=exx;
    result:= false;
   end;

begin
ex[0].pid:=0;
  for I := Low(FProcList) to High(FProcList) do
  begin
    ProcHand := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ,
      False, FProcList[I]);
    if ProcHand > 0 then
      try
        ModHand:=0;
        if EnumProcessModules(Prochand, @ModHand, 1, Count) then
        if GetModuleFileNameEX(Prochand, ModHand, ModName,
          SizeOf(ModName)) > 0 then
        begin
          ex[0].PID:=ex[0].PID+1;
          ex[ex[0].PID].Name:=FileNameEX(ModName);
          ex[ex[0].PID].PID:=FProcList[I];
          ex[ex[0].PID].Time:=timetostr(now);
          ex[ex[0].PID].VDM:=0;
          if UpperCase(ExtractFileName(ModName))='NTVDM.EXE' then // Enum 16-bit tasks
          begin
            ex[ex[0].PID].VDM:=ex[ex[0].PID].PID;
            try
              hInstLib2:=LoadLibraryA('VDMDBG.DLL');
              FuncPtr:=GetProcAddress(hInstLib2,'VDMEnumTaskWOWEx');
              if FuncPtr<>nil then
                begin
                  @VDMEnum:=FuncPtr;
                  VDMEnum( FProcList[I], @callback, @ex);
                  FuncPtr:=nil;
                end;
              finally
              FreeLibrary(hInstLib2);
              end;
          end;
        end;
      finally
        CloseHandle(ProcHand);
      end;
  end;
end;


procedure ListProcX(var ex: PRSnapShoot); //   . ex[0].PID - - 
var
  ft1,ft2,ft3,ft4:filetime;
  Count: DWORD;
  BigArray: array[0..$3FFF - 1] of DWORD;
  prochand, fsnap:THandle;
  PE: TProcessEntry32;
begin
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    begin
      EnablePrivilege('SeDebugPrivilege'); //  NT        ( .. SYSTEM)
    end;
ex[0].PID:=0;
  // Get array of process IDs
    if not EnumProcesses(@BigArray, SizeOf(BigArray), Count) then
      begin
        FSnap := CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS, 0);
        if FSnap = INVALID_HANDLE_VALUE then
            exit;
        PE.dwSize := SizeOf(PE);
        if Process32First(fSnap, PE) then               // get process
          repeat
            ex[0].PID:=ex[0].PID+1;
            ex[ex[0].PID].Name:=FileNameEX(pe.szExeFile);
            ex[ex[0].PID].PID:=pe.th32ProcessID;
            ex[ex[0].PID].VDM:=0;
            ex[ex[0].PID].Time:=timetostr(now);
          until not Process32Next(FSnap, PE);           // get next process
      closehandle(fsnap);
      end else
      begin
        SetLength(FProcList, Count div SizeOf(DWORD));
        Move(BigArray, FProcList[0], Count);
        FillProcData(ex);
      end;

end;

function AppKill(PID, VDM: cardinal):boolean; // .   16-,  VDM   PID' NTVDM.EXE , VDM = 0
type TVDMTerm= function(VDM_, PID_: dword): boolean; stdcall;
var
hInstLib2, ProcHand: thandle;
FuncPtr: pointer;
r: boolean;
VDMTerm: TVDMTerm;
begin
r:=false;
if pid>0 then
try
  if Win32Platform = VER_PLATFORM_WIN32_NT then
    begin
      EnablePrivilege('SeSystemEnvironmentPrivilege');
      EnablePrivilege('SeDebugPrivilege');
    end;
  if vdm=0 then
    begin
      ProcHand := OpenProcess(PROCESS_ALL_ACCESS, False, PID);
      if (ProcHand>0)and(terminateprocess(ProcHand,0)) then r:=true else r:=false;
      CloseHandle(ProcHand);
    end else
    begin
      try
       hInstLib2:=LoadLibraryA('VDMDBG.DLL');
       FuncPtr:=GetProcAddress(hInstLib2,'VDMTerminateTaskWOW');
       if FuncPtr<>nil then
         begin
           @VDMTerm:=FuncPtr;
           r:=VDMTerm(VDM, PID);
           FuncPtr:=nil;
         end;
       finally
         FreeLibrary(hInstLib2);
       end;
    end;
except r:=false end;

result:=r;
end;

procedure SuspendProc(PID:cardinal); //  Win *NT " "
var
  ex: TGrey;
  x: Integer;
  card: Cardinal;
begin
BuildThreadsList(pid, ex);
for x:=1 to ex[0] do
  begin
    card:=OpenThread(THREAD_SUSPEND_RESUME,false,ex[x], PID);
    if card>0 then SuspendThread(card);
  end;
end;

procedure ResumeProc(PID:cardinal); //  Win *NT " "
var
ex: TGrey;
x: Integer;
card: Cardinal;
begin
BuildThreadsList(pid, ex);
for x:=1 to ex[0] do
  begin
    card:=OpenThread(THREAD_SUSPEND_RESUME,false,ex[x], PID);
    if card>0 then ResumeThread(card);
  end;
end;

procedure BuildThreadsList(ProcessID: DWORD; var ex:TGrey); //   Thread'
var
  SnapProcHandle: THandle;
  ThreadEntry: TThreadEntry32;
  Next: Boolean;
begin
  try
    ex[0]:=0;
    SnapProcHandle := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
    if SnapProcHandle <> THandle(-1) then
    begin
      ThreadEntry.dwSize := Sizeof(ThreadEntry);
      Next := Thread32First(SnapProcHandle, ThreadEntry);
      while Next do
      begin
        if ThreadEntry.th32OwnerProcessID = ProcessID then
          begin
            ex[0]:=ex[0]+1;
            ex[ex[0]]:=ThreadEntry.th32ThreadID;
          end;
        Next := Thread32Next(SnapProcHandle, ThreadEntry);
      end;
      CloseHandle(SnapProcHandle);
    end;
  finally
  end;
end;

end.
